package com.example.aped.ui.visualization;


import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.TextView;
import com.example.aped.MainActivity;
import com.example.aped.R;
import java.util.ArrayList;
import java.util.List;


public class MainListViewAdapter extends BaseAdapter {
    /**
     * Einbinden der MainActivity.
     */
    private MainActivity mainActivity;
    /**
     * Which view was selected, 0 for all IOs, 1 for favorite IOs.
     */
    private int favoriteMode;
    /**
     * Name of the device for the current run.
     */
    private String deviceName;
    /**
     * Image for favorite or not.
     */
    private int favoriteImage;
    /**
     * List of favorites existing when opening the favorites view.
     */
    private List<String> favoritenList;


    /**
     * @param pMainActivity
     * @param pFavoriteMode
     */
    public MainListViewAdapter(final MainActivity pMainActivity,
                               final int pFavoriteMode) {
        this.mainActivity = pMainActivity;
        this.favoriteMode = pFavoriteMode;
    }

    /**
     * @return devices number
     */
    @Override
    public int getCount() {
        int devices;
        if (favoriteMode == 0) {
            devices = mainActivity.xml.getDeviceNames().size();
        } else {
            devices = mainActivity.favorite.getFavorites().size();
            favoritenList = new ArrayList<>(mainActivity.favorite.
                    getFavorites());
        }
        return devices;
    }

    /**
     * @param position
     * @return
     */
    @Override
    public Object getItem(final int position) {

        return null;
    }

    /**
     * @param position
     * @return
     */
    @Override
    public long getItemId(final int position) {

        return 0;
    }

    /**
     * @param i
     * @param view
     * @param viewGroup
     * @return view
     */
    @Override
    public View getView(final int i, View view,
                        final ViewGroup viewGroup) {
        view = mainActivity.getLayoutInflater().inflate(R.layout.
                listview_layout, null);
        TextView textViewName = (TextView) view.findViewById(R.id.textName);
        LinearLayout linearLayoutPin = (LinearLayout) view.findViewById(R.id.
                idLinearLayoutPins);
        ImageView buttonViewFavoriten = (ImageView) view.findViewById(R.id.
                imageButtonFavoriten);
        if (favoriteMode == 0) {
            deviceName = mainActivity.xml.getDeviceNames().get(i);
        } else {
            deviceName = mainActivity.favorite.getFavorites().get(i);
        }

        if (mainActivity.favorite.getFavorites().contains(deviceName)) {
            favoriteImage = android.R.drawable.btn_star_big_on;
        } else {
            favoriteImage = android.R.drawable.btn_star_big_off;
        }
        buttonViewFavoriten.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(final View view) {

                if (favoriteMode == 0) {
                    deviceName = mainActivity.xml.getDeviceNames().get(i);
                } else {
                    deviceName = favoritenList.get(i);
                }
                if (mainActivity.favorite.getFavorites().contains(deviceName)) {
                    mainActivity.favorite.removeFavorite(deviceName);
                    favoriteImage = android.R.drawable.btn_star_big_off;
                    buttonViewFavoriten.setImageResource(favoriteImage);
                } else {
                    mainActivity.favorite.addFavorite(deviceName);
                    favoriteImage = android.R.drawable.btn_star_big_on;
                    buttonViewFavoriten.setImageResource(favoriteImage);
                }
            }
        });
        PinView pinView = new PinView(mainActivity, deviceName);
        for (int j = 0; j < ((List<String>) mainActivity.xml.
                getPort(deviceName).get("pins")).size(); j++) {
            linearLayoutPin.addView(pinView.getView(j));
        }
        String name = null;
        switch ((mainActivity.xml.getPort(deviceName)).get("protocol").
                toString()) {
            case "PWM":
                name = ((mainActivity.xml.getPort(deviceName)).get("protocol").
                        toString() + ": " + deviceName + " (" + (mainActivity.
                        xml.getPort(deviceName)).get("frequency").toString()
                        + "Hz)");
                break;
            default:
                name = ((mainActivity.xml.getPort(deviceName)).get("protocol").
                        toString() + ": " + deviceName);
                break;
        }
        textViewName.setText(name);
        buttonViewFavoriten.setImageResource(favoriteImage);
        return view;
    }
}
