package com.example.aped.utils;

import java.util.ArrayList;
import java.util.List;

/**
 * implementation for the favorites interface
 * does not use persistent storage!
 */
public class TestFavorites implements IFAVORITES {

    /**
     * Liste der favoriten.
     */
    private List<String> favorites = new ArrayList<>();

    /**
     * @return
     */
    @Override
    public List<String> getFavorites() {
        return favorites;
    }

    /**
     * @param deviceName the name of the device to be added
     * @return
     */
    @Override
    public String addFavorite(final String deviceName) {
        if (!favorites.contains(deviceName)) {
          favorites.add(deviceName);
        }
        return deviceName;
    }

    /**
     * @param deviceName the name of the device to be removed
     * @return
     */
    @Override
    public String removeFavorite(final String deviceName) {
        if (favorites.contains(deviceName)) {
           favorites.remove(deviceName);
        }
        return deviceName;
    }
}
